Attribute VB_Name = "mTransForm"
Option Explicit

Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Public Function RenderForm(hWnd As Long, cPicture As StdPicture, cTransparent As Long)
Dim hRgn As Long, tRgn As Long
Dim x As Integer, y As Integer, x0 As Integer
Dim BM As BITMAP

Dim hDC As Long
hDC = CreateCompatibleDC(0)
If hDC Then
    SelectObject hDC, cPicture
    GetObject cPicture, Len(BM), BM
    hRgn = CreateRectRgn(0, 0, BM.bmWidth, BM.bmHeight)
    For y = 0 To BM.bmHeight
    For x = 0 To BM.bmWidth
        While x <= BM.bmWidth And GetPixel(hDC, x, y) <> cTransparent
            x = x + 1
        Wend
        
        x0 = x
        
        While x <= BM.bmWidth And GetPixel(hDC, x, y) = cTransparent
            x = x + 1
        Wend
        
        If x0 < x Then
            tRgn = CreateRectRgn(x0, y, x, y + 1)
            CombineRgn hRgn, hRgn, tRgn, 4
            DeleteObject tRgn
        End If
    Next x
    Next y

    DeleteObject SelectObject(hDC, cPicture)
End If

DeleteDC hDC
SetWindowRgn hWnd, hRgn, True
End Function

